import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { AuthGuard } from 'src/app/Shared/guards/auth.guard';
import { OrdenancesFormComponent } from './components/ordenances-form/ordenances-form.component';
import { OrdenancesListComponent } from './components/ordenances-list/ordenances-list.component';

const routes: Routes = [
  {
    path: 'ordenances-list',
    component: OrdenancesListComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'ORDENANCES',
    },
  },
  {
    path: 'ordenances-form/:accio/:karticle',
    component: OrdenancesFormComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'ORDENANCES',
    },
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class OrdenancesRoutingModule {}
