import { HttpClientTestingModule } from '@angular/common/http/testing';
import { CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA } from '@angular/core';
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Router } from '@angular/router';
import { RouterTestingModule } from '@angular/router/testing';
import { provideMockStore } from '@ngrx/store/testing';
import { AuthDTO } from 'src/app/Modules/auth/models/auth.dto';
import { ActaDTO } from '../../model/acta.dto';
import { PersonaInfoComponent } from './persona-info.component';
//mock lista de categorías

const updateActa: ActaDTO = new ActaDTO();

const initialAuthState = {
  authentication: new AuthDTO(
    'admin',
    'acces_token',
    'refresh_token',
    false,
    []
  ),
  loggedIn: false,
  processing: false,
  logged: true,
  passwordChanged: false,
  error: null,
};

const initialState = { auth: initialAuthState };

class TemporalComponentForRoutes {}
describe('PersonaInfoComponent', () => {
  let component: PersonaInfoComponent;
  let fixture: ComponentFixture<PersonaInfoComponent>;

  beforeEach(() =>
    TestBed.configureTestingModule({
      imports: [
        HttpClientTestingModule,
        ReactiveFormsModule,
        FormsModule,
        RouterTestingModule.withRoutes([
          {
            path: 'sancio/menu',
            component: TemporalComponentForRoutes,
          },
        ]),
      ],
      declarations: [PersonaInfoComponent],
      providers: [provideMockStore({ initialState })],
      schemas: [CUSTOM_ELEMENTS_SCHEMA, NO_ERRORS_SCHEMA],
    }).compileComponents()
  );

  beforeEach(() => {
    fixture = TestBed.createComponent(PersonaInfoComponent);
    //    store = TestBed.inject(MockStore);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('PersonaInfoComponent creado correctamente', () => {
    expect(component).toBeTruthy();
  });

  it('Navegamos correctamente cunado queremos añadir una multa a un sancionado', () => {
    const router = TestBed.inject(Router);
    const spy = spyOn(router, 'navigateByUrl');
    component.afegirActa();
    expect(spy).toHaveBeenCalledWith('sancio/menu');
  });

  it('Navegamos correctamente cunado queremos consultar una multa de un sancionado', () => {
    const router = TestBed.inject(Router);
    const spy = spyOn(router, 'navigateByUrl');
    component.updateActa(updateActa);
    expect(spy).toHaveBeenCalledWith('sancio/menu');
  });
});
