import { Component, HostListener, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { ValinfoDTO } from '../../model/valinfo.dto';
import { MenuSancioService } from '../../services/menu-sancions.service';

@Component({
  selector: 'app-redsysval',
  templateUrl: './redsysval.component.html',
  styleUrls: ['./redsysval.component.scss'],
})
export class RedsysvalComponent implements OnInit {
  @HostListener('window:message', ['$event'])
  onMessage(event: any) {
    let acta = this.menuSancioService.getActa();
    if (acta.rebut) {
      acta.rebut.estat = 'C';
      acta.rebut.operaciotpv = this.valinfo.orderinfo;
      acta.rebut.tpcobro = 'T';
    }
    this.menuSancioService.setActa(acta);
    this.router.navigateByUrl('sancio/menu/impressio');
  }

  valinfo: ValinfoDTO;

  constructor(
    private menuSancioService: MenuSancioService,
    private router: Router
  ) {
    this.valinfo = menuSancioService.getValinfo();
  }

  ngOnInit(): void {
    const iframe = document.getElementById('redsysval') as HTMLIFrameElement;
    /*let html = '';
    html += '<p>Validación siper</p>';
    html += '<form action="' + this.valinfo.acsurl + '" method="post">';
    html +=
      '<p>PAReq:<input name="PaReq" id="PAReq" type="text" value="' +
      this.valinfo.pareq +
      '"/></p>';
    html +=
      '<p>MD:<input name="MD" id="MD" type="text" value="' +
      this.valinfo.md +
      '" /></p>';
    html +=
      '<p><input name="TermUrl" id="TermUrl" value="http://localhost:8000/SancionesApi/respuestaredsys.jsp"/></p>';
    html += '<button type="submit">Send</button>';
    html += '</form>';
    iframe.innerHTML = html;*/
    const url =
      //this.valinfo.acsurl +
      'http://localhost:8000/SancionesApi/valredsys.jsp' +
      '?MD=' +
      this.valinfo.md;

    if (iframe && iframe.contentWindow)
      iframe.contentWindow.location.replace(url);
  }
}
