import { ArticleDTO } from '../../ordenances/model/article.dto';
import { FirmaActaDTO } from './firma-acta.dto';
import { FotoActaDTO } from './foto-acta.dto';
import { IdentificacioDTO } from './identificacio.dto';
import { NotificacioDTO } from './notificacio.dto';
import { RebutDTO } from './rebut.dto';

export class ActaDTO {
  kacta?: number;
  article: ArticleDTO;
  descripcio: string;
  data: Date;
  formattedData?: string;
  numActa?: number;
  situkvia?: number;
  situktipcarrer: string;
  situnomvia: string;
  situnro?: number;
  situlletra: string;
  situportal: string;
  situbloc: string;
  situkm?: number;
  situampliacio: string;
  situescala: string;
  situplanta: string;
  situporta: string;
  denunciat: IdentificacioDTO;
  denunciant: IdentificacioDTO;
  domacc: NotificacioDTO;
  rebut?: RebutDTO;
  firmes?: FirmaActaDTO[];
  fotos?: FotoActaDTO[];

  constructor() {
    this.article = new ArticleDTO(0, '', '', null, null, null);
    this.data = new Date();
    this.situktipcarrer = '';
    this.situnomvia = '';
    this.situlletra = '';
    this.situportal = '';
    this.situbloc = '';
    this.situampliacio = '';
    this.situescala = '';
    this.situplanta = '';
    this.situporta = '';
    this.denunciat = new IdentificacioDTO();
    this.denunciant = new IdentificacioDTO();
    this.domacc = new NotificacioDTO();
    this.descripcio = '';
  }
}
