/*
    // Test
    <script
      async
      defer
      src="https://sis-t.redsys.es:25443/sis/NC/sandbox/redsysV2.js"
    ></script>

*/

export const REDSYS_DOMAIN: string = 'https://sis-t.redsys.es:25443';
export const IFRAME_REDSYS: string = 'redsys-hosted-pay-button';

export let result3DSMethod: string = '';
export let id3DSMethod = '';

export function getCardInput(id: string, style: string) {
  const div: HTMLElement | null = document.getElementById(id);
  const frame = document.createElement('iframe');
  frame.setAttribute('id', 'redsys-hosted-field-number');
  frame.setAttribute('name', 'redsys-hosted-field-number');
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute('type', 'number');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('sandbox', 'allow-same-origin allow-scripts');
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?style=' +
      toHex(style) +
      '&frame=cardNumber&version=V2'
  );
  if (div) div.appendChild(frame);
}

export function getExpirationYearInput(id: string, style: string) {
  const div: HTMLElement | null = document.getElementById(id);
  const frame = document.createElement('iframe');
  frame.setAttribute('id', 'redsys-hosted-field-expirationYear');
  frame.setAttribute('name', 'redsys-hosted-field-expirationYear');
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?style=' +
      toHex(style) +
      '&frame=expirationYear&version=V2'
  );
  frame.setAttribute('type', 'tel');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('sandbox', 'allow-same-origin allow-scripts');
  if (div) div.appendChild(frame);
}

export function getExpirationMonthInput(id: string, style: string) {
  const div: HTMLElement | null = document.getElementById(id);
  const frame = document.createElement('iframe');
  frame.setAttribute('id', 'redsys-hosted-field-expirationMonth');
  frame.setAttribute('name', 'redsys-hosted-field-expirationMonth');
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?style=' +
      toHex(style) +
      '&frame=expirationMonth&version=V2'
  );
  frame.setAttribute('type', 'tel');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('sandbox', 'allow-same-origin allow-scripts');
  if (div) div.appendChild(frame);
}

export function getCVVInput(id: string, style: string) {
  const div: HTMLElement | null = document.getElementById(id);
  const frame = document.createElement('iframe');
  frame.setAttribute('id', 'redsys-hosted-field-cvv');
  frame.setAttribute('name', 'redsys-hosted-field-cvv');
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute('type', 'number');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('sandbox', 'allow-same-origin allow-scripts');
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?style=' +
      toHex(style) +
      '&frame=cvv&version=V2'
  );
  if (div) div.appendChild(frame);
}

export function getPayButton(
  id: string,
  style: string,
  buttonValue: string,
  fuc: string,
  terminal: string,
  order: string
) {
  const div: HTMLElement | null = document.getElementById(id);
  const frame = document.createElement('iframe');
  frame.setAttribute('id', IFRAME_REDSYS);
  frame.setAttribute('name', IFRAME_REDSYS);
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute('type', 'number');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('onload', 'setMerchantDomain(500);');
  frame.setAttribute('sandbox', 'allow-same-origin allow-scripts allow-modals');
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?buttonValue=' +
      toHex(buttonValue) +
      '&style=' +
      toHex(style) +
      '&frame=button&fuc=' +
      toHex(fuc) +
      '&terminal=' +
      toHex(terminal) +
      '&order=' +
      toHex(order) +
      '&version=V2'
  );
  if (div) div.appendChild(frame);
}

export function getInSiteForm(
  id: string,
  styleButton: string,
  styleBody: string,
  styleBox: string,
  styleBoxText: string,
  buttonValue: string,
  fuc: string,
  terminal: string,
  order: string,
  idioma: string,
  mostrarLogo: boolean
) {
  const div: HTMLElement | null = document.getElementById(id);
  const idiomaInsite = idioma || 'ES';
  const mostrarLogoInsite =
    typeof mostrarLogo !== 'undefined' ? mostrarLogo : true;

  const frame = document.createElement('iframe');
  frame.setAttribute('id', IFRAME_REDSYS);
  frame.setAttribute('name', IFRAME_REDSYS);
  frame.setAttribute('style', 'width: 100%; height: 100%;');
  frame.setAttribute('frameborder', '0');
  frame.setAttribute('type', 'number');
  frame.setAttribute('scrolling', 'no');
  frame.setAttribute('onload', 'setMerchantDomain(500);');
  frame.setAttribute(
    'sandbox',
    'allow-same-origin allow-scripts allow-modals allow-popups'
  );
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?buttonValue=' +
      toHex(buttonValue) +
      '&styleButton=' +
      toHex(styleButton) +
      '&styleBody=' +
      toHex(styleBody) +
      '&styleBox=' +
      toHex(styleBox) +
      '&styleBoxText=' +
      toHex(styleBoxText) +
      '&frame=inSite&fuc=' +
      toHex(fuc) +
      '&terminal=' +
      toHex(terminal) +
      '&order=' +
      toHex(order) +
      '&version=V2' +
      '&idioma=' +
      idiomaInsite +
      '&mostrarLogo=' +
      mostrarLogoInsite
  );
  if (div) div.appendChild(frame);
}

export function init3DS(id: string, emv3ds: string) {
  const div: HTMLElement | null = document.getElementById(id);
  if (div) {
    div.innerHTML =
      "<div id='fadeFrame' style='position: absolute;top: 0;left: 0;width: 100%;height: 100%;background: #000;z-index:1001;opacity:.75;-moz-opacity: 0.75;filter: alpha(opacity=75);'><button style='position:absolute;left:50%;top:90%;opacity:initial;' onclick=document.getElementById('fadeFrame').remove();document.getElementById('lightFrame').remove();>Cerrar</button></div><div id='lightFrame' style='position: absolute;top: 25%;left: 25%;width: 50%;height: 50%;padding: 16px;background: #fff;color: #333;z-index:1002;overflow: auto;'></div>";
    let frame = document.createElement('iframe');
    frame.setAttribute('id', 'redsys-hosted-field-3ds');
    frame.setAttribute('name', 'redsys-hosted-field-3ds');
    frame.setAttribute('style', 'width: 100%; height: 100%;');
    frame.setAttribute('frameborder', '0');
    frame.setAttribute('scrolling', 'no');
    frame.setAttribute(
      'sandbox',
      'allow-same-origin allow-scripts allow-forms'
    );
    frame.setAttribute(
      'src',
      REDSYS_DOMAIN +
        '/sis/getInputNC?emv3ds=' +
        toHex(emv3ds) +
        '&frame=3ds&version=V2'
    );
    const lightFrame: HTMLElement | null =
      document.getElementById('lightFrame');
    if (lightFrame) lightFrame.appendChild(frame);
  }
}

export function execute3DSMethod(
  id: string,
  threeDSMethodURL: string,
  threeDSServerTransID: string
) {
  const id3DSMethod = id;

  let frame = document.createElement('iframe');
  frame.setAttribute('id', 'redsys-hosted-field-3dsmethod');
  frame.setAttribute('name', 'redsys-hosted-field-3dsmethod');
  frame.setAttribute(
    'style',
    'width:0;height:0;border:0;border:none;display:none;'
  );
  frame.setAttribute(
    'src',
    REDSYS_DOMAIN +
      '/sis/getInputNC?threeDSMethodURL=' +
      threeDSMethodURL +
      '&threeDSServerTransID=' +
      threeDSServerTransID +
      '&frame=3dsmethod&version=V2'
  );
  document.getElementsByTagName('BODY')[0].appendChild(frame);
  let result3DSMethod = '';
  setTimeout(function () {
    if (result3DSMethod == '') {
      result3DSMethod = 'N';
      const elmeMid3DSMethod: HTMLInputElement | null = document.getElementById(
        id3DSMethod
      ) as HTMLInputElement;
      elmeMid3DSMethod.value = result3DSMethod;
    }
  }, 10000);
}

export function toHex(str: string) {
  let hex = '';
  for (let i = 0; i < str.length; i++) {
    hex += '' + str.charCodeAt(i).toString(16);
  }
  return hex;
}

export function hex2a(hex: string) {
  let str = '';
  for (let i = 0; i < hex.length; i += 2) {
    let v = parseInt(hex.substring(i, 2), 16);
    if (v) str += String.fromCharCode(v);
  }
  return str;
}

export function storeIdOper(ev: any, id: string, err: string) {
  if (ev.data.idOper && ev.origin == REDSYS_DOMAIN) {
    (document.getElementById(err) as HTMLInputElement).value = '';
    (document.getElementById(id) as HTMLInputElement).value = ev.data.idOper;
  } else if (ev.data.error && ev.origin == REDSYS_DOMAIN) {
    (document.getElementById(id) as HTMLInputElement).value = '';
    (document.getElementById(err) as HTMLInputElement).value = ev.data.error;
  } else if (ev.data == 'merchantValidation' && ev.origin == REDSYS_DOMAIN) {
    let iFrame: any = document.getElementById(IFRAME_REDSYS);
    iFrame.postMessage({ validation: 'OK' }, REDSYS_DOMAIN);

    /*window.frames[IFRAME_REDSYS].postMessage(
        { validation: 'OK' },
        REDSYS_DOMAIN
      );*/
  } else if (ev.data.result3DSMethod) {
    let result3DSMethod = ev.data.result3DSMethod;
    (document.getElementById(id3DSMethod) as HTMLInputElement).value =
      result3DSMethod;
  }
}

export function set3DSResult(ev: any, id: string) {
  if (ev.data.DS_MERCHANT_EMV3DS && ev.origin == REDSYS_DOMAIN) {
    (document.getElementById(id) as HTMLInputElement).value = JSON.stringify(
      ev.data.DS_MERCHANT_EMV3DS
    );
    close3DS();
  }
}

export function close3DS() {
  let elmLf = document.getElementById('lightFrame');
  if (elmLf) elmLf.style.display = 'none';

  let elmFf = document.getElementById('fadeFrame');
  if (elmFf) elmFf.style.display = 'none';
}

//Deprecated
export function loadRedsysForm() {}

export function setMerchantDomain(time: number) {
  setTimeout(function () {
    let iFrame: any = document.getElementById(IFRAME_REDSYS);
    iFrame.postMessage('domain', REDSYS_DOMAIN);
  }, time);
}
