import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { AuthGuard } from 'src/app/Shared/guards/auth.guard';
import { ActaComponent } from './components/acta/acta.component';
import { ActesListComponent } from './components/actes-list/actes-list.component';
import { FirmaComponent } from './components/firma/firma.component';
import { FotosComponent } from './components/fotos/fotos.component';
import { ImpressioComponent } from './components/impressio/impressio.component';
import { InsiteComponent } from './components/insite/insite.component';
import { MenuSancioComponent } from './components/menu-sancio/menu-sancio.component';
import { NotificacionsComponent } from './components/notificacions/notificacions.component';
import { PersonaInfoComponent } from './components/persona-info/persona-info.component';
import { PersonesListComponent } from './components/persones-list/persones-list.component';
import { RedsysvalComponent } from './components/redsysval/redsysval.component';
import { SituacioComponent } from './components/situacio/situacio.component';

const routes: Routes = [
  {
    path: 'actes-list',
    component: ActesListComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'SANCIO',
    },
  },
  {
    path: 'persones-list',
    component: PersonesListComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'INFO',
    },
  },
  {
    path: 'persona-info/:kpersona',
    component: PersonaInfoComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'INFO',
    },
  },
  {
    path: 'menu',
    component: MenuSancioComponent,
    canActivate: [AuthGuard],
    data: {
      option: 'SANCIO',
    },
    children: [
      {
        path: '',
        component: ActaComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'acta',
        component: ActaComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'notificacions',
        component: NotificacionsComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'situacio',
        component: SituacioComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'firma',
        component: FirmaComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'fotos',
        component: FotosComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'impressio',
        component: ImpressioComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'insite',
        component: InsiteComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
      {
        path: 'redsysval',
        component: RedsysvalComponent,
        canActivate: [AuthGuard],
        data: {
          option: 'SANCIO',
        },
      },
    ],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class SancioRoutingModule {}
