import { LayoutModule } from '@angular/cdk/layout';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import { ReactiveFormsModule } from '@angular/forms';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatDialogModule } from '@angular/material/dialog';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatTableModule } from '@angular/material/table';
import { MatToolbarModule } from '@angular/material/toolbar';
import { IvyCarouselModule } from 'angular-responsive-carousel';
import { NgxBarcodeModule } from 'ngx-barcode';
import { NgxPrintModule } from 'ngx-print';
import { WebcamModule } from 'ngx-webcam';
import { ActaComponent } from './components/acta/acta.component';
import { ActesListComponent } from './components/actes-list/actes-list.component';
import { FirmaComponent } from './components/firma/firma.component';
import { FotosComponent } from './components/fotos/fotos.component';
import { ImpressioComponent } from './components/impressio/impressio.component';
import { InsiteComponent } from './components/insite/insite.component';
import {
  DialogInvalidMessage,
  MenuSancioComponent,
} from './components/menu-sancio/menu-sancio.component';
import { NotificacionsComponent } from './components/notificacions/notificacions.component';
import { PersonaInfoComponent } from './components/persona-info/persona-info.component';
import { PersonesListComponent } from './components/persones-list/persones-list.component';
import { RedsysvalComponent } from './components/redsysval/redsysval.component';
import { SituacioComponent } from './components/situacio/situacio.component';
import { DrawingDirective } from './directives/drawing.directive';
import { SancioRoutingModule } from './sancio-routing.module';

@NgModule({
  declarations: [
    ActaComponent,
    MenuSancioComponent,
    NotificacionsComponent,
    SituacioComponent,
    DialogInvalidMessage,
    ImpressioComponent,
    ActesListComponent,
    FirmaComponent,
    DrawingDirective,
    PersonesListComponent,
    PersonaInfoComponent,
    FotosComponent,
    InsiteComponent,
    RedsysvalComponent,
  ],
  imports: [
    ReactiveFormsModule,
    CommonModule,
    MatFormFieldModule,
    MatInputModule,
    MatButtonModule,
    MatIconModule,
    MatToolbarModule,
    FlexLayoutModule,
    LayoutModule,
    MatSelectModule,
    MatAutocompleteModule,
    MatRadioModule,
    MatButtonToggleModule,
    MatDialogModule,
    MatSlideToggleModule,
    MatTableModule,
    MatCardModule,
    SancioRoutingModule,
    NgxPrintModule,
    NgxBarcodeModule,
    WebcamModule,
    IvyCarouselModule,
  ],
})
export class SancioModule {}
