import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { apiconfig } from 'src/app/Shared/model/apitool';
import { MunicipiDTO } from '../model/municipi.dto';
import { PaisDTO } from '../model/pais.dto';
import { ProvinciaDTO } from '../model/provincia.dto';
import { TipCarrerDTO } from '../model/tipcarrer.dto';
import { ViaDTO } from '../model/via.dto';

@Injectable({
  providedIn: 'root',
})
export class CadastreService {
  private urlApi: string;
  private controller: string;

  constructor(private http: HttpClient) {
    this.controller = 'Cadastre/';
    this.urlApi = apiconfig.apiurl + this.controller;
  }

  getTipCarrers(): Observable<TipCarrerDTO[]> {
    return this.http.get<TipCarrerDTO[]>(this.urlApi + 'tipcarrers');
  }

  getPaisos(): Observable<PaisDTO[]> {
    return this.http.get<PaisDTO[]>(this.urlApi + 'paisos');
  }

  getProvincies(): Observable<ProvinciaDTO[]> {
    return this.http.get<ProvinciaDTO[]>(this.urlApi + 'provincies');
  }

  getMunicipis(kprovincia: string): Observable<MunicipiDTO[]> {
    return this.http.get<MunicipiDTO[]>(
      this.urlApi + 'municipis?kprovincia=' + kprovincia
    );
  }

  getVies(kmunicipi: string): Observable<ViaDTO[]> {
    return this.http.get<ViaDTO[]>(
      this.urlApi + 'vies?kmunicipi=' + kmunicipi
    );
  }
}
