import { EventEmitter, Injectable, Output } from '@angular/core';
import { ActaDTO } from '../model/acta.dto';
import { ValinfoDTO } from '../model/valinfo.dto';

@Injectable({
  providedIn: 'root',
})

//http://developinginspanish.com/2018/05/19/3-formas-de-comunicarse-entre-componentes-angular/
export class MenuSancioService {
  private acta: ActaDTO;
  private url: string;
  private valinfo: ValinfoDTO;

  constructor() {
    this.acta = new ActaDTO();
    this.url = 'sancio/actes-list';
    this.valinfo = new ValinfoDTO();
  }

  getActa(): ActaDTO {
    return this.acta;
  }

  setActa(acta: ActaDTO): void {
    this.acta = acta;
  }

  getURL(): string {
    return this.url;
  }

  setUrl(url: string) {
    this.url = url;
  }

  getValinfo(): ValinfoDTO {
    return this.valinfo;
  }

  setValinfo(valinfo: ValinfoDTO): void {
    this.valinfo = valinfo;
  }

  @Output() change: EventEmitter<boolean> = new EventEmitter();
  @Output() validated: EventEmitter<boolean> = new EventEmitter();
}
