import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { apiconfig } from 'src/app/Shared/model/apitool';
import { IdentificacioDTO } from '../model/identificacio.dto';
import { SancionatDTO } from '../model/sancionat.dto';

@Injectable({
  providedIn: 'root',
})
export class PersonaService {
  private urlApi: string;
  private controller: string;

  constructor(private http: HttpClient) {
    this.controller = 'persona/';
    this.urlApi = apiconfig.apiurl + this.controller;
  }

  findById(kpersona: number): Observable<IdentificacioDTO> {
    return this.http.get<IdentificacioDTO>(
      this.urlApi + 'findById/' + kpersona
    );
  }

  findByNif(nif: string): Observable<IdentificacioDTO> {
    return this.http.get<IdentificacioDTO>(this.urlApi + 'findByNif/' + nif);
  }

  findByPassaport(passaport: string): Observable<IdentificacioDTO> {
    return this.http.get<IdentificacioDTO>(
      this.urlApi + 'findByPassaport/' + passaport
    );
  }

  findByDocument(document: string): Observable<IdentificacioDTO> {
    return this.http.get<IdentificacioDTO>(
      this.urlApi + 'findByDocument/' + document
    );
  }

  findSancionatByNom(nom: string): Observable<SancionatDTO[]> {
    return this.http.get<SancionatDTO[]>(
      this.urlApi + 'filterByName?nom=' + nom
    );
  }

  findSancionatByDocument(document: string): Observable<SancionatDTO> {
    return this.http.get<SancionatDTO>(
      this.urlApi + 'findSancionatByDocument/' + document
    );
  }
}
