import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { apiconfig } from 'src/app/Shared/model/apitool';
import { ActaDTO } from '../model/acta.dto';
import { PayinfoDTO } from '../model/payinfo.dto';
import { ValinfoDTO } from '../model/valinfo.dto';

@Injectable({
  providedIn: 'root',
})
export class TpvService {
  private urlApi: string;

  constructor(private http: HttpClient) {
    this.urlApi = apiconfig.apiurl + 'tpv';
  }

  pay(payinfo: PayinfoDTO): Observable<ActaDTO> {
    return this.http.post<ActaDTO>(this.urlApi + '/pay', payinfo);
  }

  prepay(payinfo: PayinfoDTO): Observable<ValinfoDTO> {
    return this.http.post<ValinfoDTO>(this.urlApi + '/preparepay', payinfo);
  }
}
