import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { HomeComponent } from './Shared/components/home/home.component';
import { AuthGuard } from './Shared/guards/auth.guard';

const routes: Routes = [
  {
    path: '',
    redirectTo: 'auth/login',
    pathMatch: 'full',
  },
  {
    path: 'auth',
    loadChildren: () =>
      import('./Modules/auth/auth.module').then((m) => m.AuthModule),
  },
  {
    path: 'home',
    component: HomeComponent,
    canActivate: [AuthGuard],
  },
  {
    path: 'users',
    loadChildren: () =>
      import('./Modules/users/users.module').then((m) => m.UsersModule),
  },
  {
    path: 'ordenances',
    loadChildren: () =>
      import('./Modules/ordenances/ordenances.module').then(
        (m) => m.OrdenancesModule
      ),
  },
  {
    path: 'sancio',
    loadChildren: () =>
      import('./Modules/sancio/sancio.module').then((m) => m.SancioModule),
  },
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule],
})
export class AppRoutingModule {}
