package controller.comu;

import java.util.List;

import javax.persistence.EntityManager;

import entity.comu.Persona;
import entity.comu.Sancionat;
import utilities.JPAFactory;

public class PersonaCtrl {
	

	public static Persona findById(Integer kpersona) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			Persona pers=em.find(Persona.class, kpersona);
			return pers;
		} finally {
			if (em!=null) em.close();
		}
	}

	
	public static Persona findByNif(String nif) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Persona> pers = em.createNamedQuery("Persona.findByNif", Persona.class)
					.setParameter("document", nif.toUpperCase()).getResultList();
			if (pers != null && pers.size() > 0) {
				return pers.get(0);
			}
			else return null;
		} finally {
			if (em!=null) em.close();
		}
	}

	public static Persona findByPassaport(String passaport) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Persona> pers = em.createNamedQuery("Persona.findByPassaport", Persona.class)
					.setParameter("document", passaport.toUpperCase()).getResultList();
			if (pers != null && pers.size() > 0) {
				return pers.get(0);
			}
			else return null;
		} finally {
			if (em!=null) em.close();
		}
	}

	public static Persona findByDocument(String document) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Persona> pers = em.createNamedQuery("Persona.findByDocument", Persona.class)
					.setParameter("document", document.toUpperCase()).getResultList();
			if (pers != null && pers.size() > 0) {
				return pers.get(0);
			}
			else return null;
		} finally {
			if (em!=null) em.close();
		}
	}

	
	public static List<Sancionat> findByNom(String nom) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Sancionat> pers = em.createNamedQuery("Persona.findByNom", Sancionat.class)
					.setParameter("nom", "%" + nom.toUpperCase() + "%")
					.setMaxResults(20)
					.getResultList();
			return pers;
		} finally {
			if (em!=null) em.close();
		}
	}
	

	public static Sancionat findSancionatByDocument(String document) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Sancionat> pers = em.createNamedQuery("Persona.findSancionatByDocument", Sancionat.class)
					.setParameter("document", document.toUpperCase())
					.getResultList();
			if (pers != null && pers.size() > 0) {
				return pers.get(0);
			}
			else return null;
		} finally {
			if (em!=null) em.close();
		}
	}	
	
}
