package controller.sancions;

import java.util.List;

import javax.persistence.EntityManager;

import entity.sancions.Article;
import utilities.JPAFactory;

public class ArticleCtrl {
	public static Article addArticle(Article article) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			em.getTransaction().begin();
			em.persist(article);
			em.getTransaction().commit();
			return article;
		} 
		catch (Exception exc) {
			if (em!=null && em.getTransaction().isActive())
				em.getTransaction().rollback();
			throw exc;
		}
		finally {
			if (em!=null) em.close();
		}
	}
	
	public static Article getArticle(Integer karticle) throws Exception{
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			Article article=em.find(Article.class, karticle);
			article.setCodi(article.getCodi().toUpperCase());
			article.setDescripcio(article.getDescripcio().toUpperCase());
			return article;
		} finally {
			if (em!=null) em.close();
		}
		
	}
	
	public static Article saveArticle(Article article) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			em.getTransaction().begin();
			em.merge(article);
			em.getTransaction().commit();
			return article;			
		} 
		catch (Exception exc) {
			if (em!=null && em.getTransaction().isActive())
				em.getTransaction().rollback();
			throw exc;
		}
		finally {
			if (em!=null) em.close();
		}
	}

	public static void deleteArticle(Integer karticle) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			em.getTransaction().begin();
			Article article=em.find(Article.class, karticle);
			em.remove(article);
			em.getTransaction().commit();
		} 
		catch (Exception exc) {
			if (em!=null && em.getTransaction().isActive())
				em.getTransaction().rollback();
			throw exc;
		}
		finally {
			if (em!=null) em.close();
		}
	}
	
	
	public static List<Article> filterByName(String name) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Article> articles = em.createNamedQuery("Article.findByNameFilter", Article.class)
					.setParameter("filter", "%" + name.toUpperCase() + "%")
					.getResultList();
			return articles;
		} finally {
			if (em!=null) em.close();
		}				
	}

	public static List<Article> filterByCode(String code) throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Article> articles = em.createNamedQuery("Article.findByCode", Article.class)
					.setParameter("filter", code.toUpperCase() + "%")
					.getResultList();
			return articles;
		} finally {
			if (em!=null) em.close();
		}				
	}

	public static List<Article> getArticles() throws Exception {
		EntityManager em = null;
		try {
			em = JPAFactory.createEntityManager();
			List<Article> articles = em.createNamedQuery("Article.findAll", Article.class)
					.getResultList();
			return articles;
		} finally {
			if (em!=null) em.close();
		}				
	}
	
	
}
