package entity.cadastre;

import java.io.Serializable;


import javax.persistence.*;

import jakarta.json.bind.annotation.JsonbTransient;

import java.util.List;


/**
 * The persistent class for the "Provincia" database table.
 * 
 */
@Entity
@Table(name="\"Provincia\"", schema = "cadastre")
@NamedQuery(name="Provincia.findAll", query="SELECT p FROM Provincia p")
public class Provincia implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	private Integer kprovincia;

	private String nom;

	//bi-directional many-to-one association to Municipi
	@OneToMany(mappedBy="provincia", fetch = FetchType.LAZY)
	@JsonbTransient
	private List<Municipi> municipis;

	public Provincia() {
	}

	public Integer getKprovincia() {
		return this.kprovincia;
	}

	public void setKprovincia(Integer kprovincia) {
		this.kprovincia = kprovincia;
	}

	public String getNom() {
		return this.nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public List<Municipi> getMunicipis() {
		return this.municipis;
	}

	public void setMunicipis(List<Municipi> municipis) {
		this.municipis = municipis;
	}

	public Municipi addMunicipi(Municipi municipi) {
		getMunicipis().add(municipi);
		municipi.setProvincia(this);

		return municipi;
	}

	public Municipi removeMunicipi(Municipi municipi) {
		getMunicipis().remove(municipi);
		municipi.setProvincia(null);

		return municipi;
	}

}