package entity.comu;

import java.io.Serializable;
import javax.persistence.*;

import utilities.AttributeUppercase;


/**
 * The persistent class for the "Domicili" database table.
 * 
 */
@Entity
@Table(name="\"Domicili\"", schema = "comu")
@NamedQuery(name="Domicili.findAll", query="SELECT d FROM Domicili d")
public class Domicili implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer kdomicili;

	@Convert(converter=AttributeUppercase.class)
	private String ampliacio;

	@Convert(converter=AttributeUppercase.class)
	private String bloc;

	private String cp;

	@Convert(converter=AttributeUppercase.class)
	private String escala;

	@Convert(converter=AttributeUppercase.class)
	private String habitacio;

	private Integer km;

	private Integer kmunicipi;

	private Integer kpais;

	private Integer kprovincia;

	private Integer kvia;

	private String lletra;

	@Convert(converter=AttributeUppercase.class)
	private String nommunicipi;

	@Convert(converter=AttributeUppercase.class)
	private String nompais;

	@Convert(converter=AttributeUppercase.class)
	private String nomprovincia;

	@Convert(converter=AttributeUppercase.class)
	private String nomvia;

	private Integer nro;

	@Convert(converter=AttributeUppercase.class)
	private String planta;

	@Convert(converter=AttributeUppercase.class)
	private String porta;

	@Convert(converter=AttributeUppercase.class)
	private String portal;

	@Convert(converter=AttributeUppercase.class)
	private String tpvia;

	public Domicili() {
	}

	public Integer getKdomicili() {
		return this.kdomicili;
	}

	public void setKdomicili(Integer kdomicili) {
		this.kdomicili = kdomicili;
	}

	public String getAmpliacio() {
		return this.ampliacio;
	}

	public void setAmpliacio(String ampliacio) {
		this.ampliacio = ampliacio;
	}

	public String getBloc() {
		return this.bloc;
	}

	public void setBloc(String bloc) {
		this.bloc = bloc;
	}

	public String getCp() {
		return this.cp;
	}

	public void setCp(String cp) {
		this.cp = cp;
	}

	public String getEscala() {
		return this.escala;
	}

	public void setEscala(String escala) {
		this.escala = escala;
	}

	public String getHabitacio() {
		return this.habitacio;
	}

	public void setHabitacio(String habitacio) {
		this.habitacio = habitacio;
	}

	public Integer getKm() {
		return this.km;
	}

	public void setKm(Integer km) {
		this.km = km;
	}

	public Integer getKmunicipi() {
		return this.kmunicipi;
	}

	public void setKmunicipi(Integer kmunicipi) {
		this.kmunicipi = kmunicipi;
	}

	public Integer getKpais() {
		return this.kpais;
	}

	public void setKpais(Integer kpais) {
		this.kpais = kpais;
	}

	public Integer getKprovincia() {
		return this.kprovincia;
	}

	public void setKprovincia(Integer kprovincia) {
		this.kprovincia = kprovincia;
	}

	public Integer getKvia() {
		return this.kvia;
	}

	public void setKvia(Integer kvia) {
		this.kvia = kvia;
	}

	public String getLletra() {
		return this.lletra;
	}

	public void setLletra(String lletra) {
		this.lletra = lletra;
	}

	public String getNommunicipi() {
		return this.nommunicipi;
	}

	public void setNommunicipi(String nommunicipi) {
		this.nommunicipi = nommunicipi;
	}

	public String getNompais() {
		return this.nompais;
	}

	public void setNompais(String nompais) {
		this.nompais = nompais;
	}

	public String getNomprovincia() {
		return this.nomprovincia;
	}

	public void setNomprovincia(String nomprovincia) {
		this.nomprovincia = nomprovincia;
	}

	public String getNomvia() {
		return this.nomvia;
	}

	public void setNomvia(String nomvia) {
		this.nomvia = nomvia;
	}

	public Integer getNro() {
		return this.nro;
	}

	public void setNro(Integer nro) {
		this.nro = nro;
	}

	public String getPlanta() {
		return this.planta;
	}

	public void setPlanta(String planta) {
		this.planta = planta;
	}

	public String getPorta() {
		return this.porta;
	}

	public void setPorta(String porta) {
		this.porta = porta;
	}

	public String getPortal() {
		return this.portal;
	}

	public void setPortal(String portal) {
		this.portal = portal;
	}

	public String getTpvia() {
		return this.tpvia;
	}

	public void setTpvia(String tpvia) {
		this.tpvia = tpvia;
	}

}