package entity.comu;

import java.io.Serializable;
import javax.persistence.*;

import entity.cadastre.Pais;
import utilities.AttributeUppercase;

import java.util.Date;


/**
 * The persistent class for the "Persona" database table.
 * 
 */
@Entity
@Table(name="\"Persona\"", schema = "comu")
@NamedQuery(name="Persona.findAll", query="SELECT p FROM Persona p")
public class Persona implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer kpersona;

	@Convert(converter=AttributeUppercase.class)
	private String activitat;

	@Temporal(TemporalType.DATE)
	private Date dataneixement;

	@Convert(converter=AttributeUppercase.class)
	private String dencomerc;

	@Convert(converter=AttributeUppercase.class)
	private String document;

	private String email;

	@ManyToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="knacionalitat")
	private Pais nacionalitat;

	@Convert(converter=AttributeUppercase.class)
	private String llinatge1;

	@Convert(converter=AttributeUppercase.class)
	private String llinatge2;

	@Convert(converter=AttributeUppercase.class)
	private String nom;

	@Convert(converter=AttributeUppercase.class)
	private String nomcomplet;

	@Convert(converter=AttributeUppercase.class)
	private String passaport;

	private String sexe;

	private String telefon;

	@Convert(converter=AttributeUppercase.class)
	private String tpdocument;

	@Convert(converter=AttributeUppercase.class)
	private String tppersona;

	//uni-directional many-to-one association to Domicili
	@ManyToOne(fetch=FetchType.LAZY, cascade=CascadeType.DETACH)
	@JoinColumn(name="kdomnotif")
	private Domicili domnotif;

	public Persona() {
	}

	public Integer getKpersona() {
		return this.kpersona;
	}

	public void setKpersona(Integer kpersona) {
		this.kpersona = kpersona;
	}

	public String getActivitat() {
		return this.activitat;
	}

	public void setActivitat(String activitat) {
		this.activitat = activitat;
	}

	public Date getDataneixement() {
		return this.dataneixement;
	}

	public void setDataneixement(Date dataneixement) {
		this.dataneixement = dataneixement;
	}

	public String getDencomerc() {
		return this.dencomerc;
	}

	public void setDencomerc(String dencomerc) {
		this.dencomerc = dencomerc;
	}

	public String getDocument() {
		return this.document;
	}

	public void setDocument(String document) {
		this.document = document;
	}

	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Pais getNacionalitat() {
		return nacionalitat;
	}

	public void setNacionalitat(Pais nacionalitat) {
		this.nacionalitat = nacionalitat;
	}

	public String getLlinatge1() {
		return this.llinatge1;
	}

	public void setLlinatge1(String llinatge1) {
		this.llinatge1 = llinatge1;
	}

	public String getLlinatge2() {
		return this.llinatge2;
	}

	public void setLlinatge2(String llinatge2) {
		this.llinatge2 = llinatge2;
	}

	public String getNom() {
		return this.nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getNomcomplet() {
		return this.nomcomplet;
	}

	public void setNomcomplet(String nomcomplet) {
		this.nomcomplet = nomcomplet;
	}

	public String getPassaport() {
		return this.passaport;
	}

	public void setPassaport(String passaport) {
		this.passaport = passaport;
	}

	public String getSexe() {
		return this.sexe;
	}

	public void setSexe(String sexe) {
		this.sexe = sexe;
	}

	public String getTelefon() {
		return this.telefon;
	}

	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	public String getTpdocument() {
		return this.tpdocument;
	}

	public void setTpdocument(String tpdocument) {
		this.tpdocument = tpdocument;
	}

	public String getTppersona() {
		return this.tppersona;
	}

	public void setTppersona(String tppersona) {
		this.tppersona = tppersona;
	}

	public Domicili getDomnotif() {
		return this.domnotif;
	}

	public void setDomnotif(Domicili domnotif) {
		this.domnotif = domnotif;
	}

}