package entity.reca;

import java.io.Serializable;
import javax.persistence.*;

import utilities.BarCodeEABQ38Format521;

import java.math.BigDecimal;
import java.util.Date;


/**
 * The persistent class for the "Rebut" database table.
 * 
 */
@Entity
@Table(name="\"Rebut\"", schema = "reca")
@NamedQuery(name="Rebut.findAll", query="SELECT r FROM Rebut r")
public class Rebut implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer krebut;

	private Integer anio;

	@Temporal(TemporalType.DATE)
	private Date data;

	@Temporal(TemporalType.DATE)
	@Column(name="data_cobro")
	private Date dataCobro;

	private String estat;

	@Column(name="import_rebut")
	private BigDecimal importRebut;

	private Integer kpersona;

	@Column(name="num_rebut")
	private Integer numRebut;

	private String ordre;

	private String padro;
	
	private String tpcobro;
	
	private String operaciotpv;
	
	private String mdredsys;
	
	private String idredsys;
	
	@Transient
	private String barcode;	
	

	public Rebut() {
	}

	public Integer getKrebut() {
		return this.krebut;
	}

	public void setKrebut(Integer krebut) {
		this.krebut = krebut;
	}

	public Integer getAnio() {
		return this.anio;
	}

	public void setAnio(Integer anio) {
		this.anio = anio;
	}

	public Date getData() {
		return this.data;
	}

	public void setData(Date data) {
		this.data = data;
	}

	public Date getDataCobro() {
		return this.dataCobro;
	}

	public void setDataCobro(Date dataCobro) {
		this.dataCobro = dataCobro;
	}

	public String getEstat() {
		return this.estat;
	}

	public void setEstat(String estat) {
		this.estat = estat;
	}

	public BigDecimal getImportRebut() {
		return this.importRebut;
	}

	public void setImportRebut(BigDecimal importRebut) {
		this.importRebut = importRebut;
	}

	public Integer getKpersona() {
		return this.kpersona;
	}

	public void setKpersona(Integer kpersona) {
		this.kpersona = kpersona;
	}

	public Integer getNumRebut() {
		return this.numRebut;
	}

	public void setNumRebut(Integer numRebut) {
		this.numRebut = numRebut;
	}

	public String getOrdre() {
		return this.ordre;
	}

	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}

	public String getPadro() {
		return this.padro;
	}

	public void setPadro(String padro) {
		this.padro = padro;
	}
	
	public String getBarcode() throws Exception {
			java.util.Calendar cal=new java.util.GregorianCalendar();
			cal.setTime(getData());
			cal.set(cal.get(java.util.Calendar.YEAR),cal.get(java.util.Calendar.MONTH),cal.get(java.util.Calendar.DATE)+10);   				
			int ipadro=new Integer(removeZeroLeft(getPadro()));
			int iordre=new Integer(removeZeroLeft(getOrdre()));
			return new BarCodeEABQ38Format521(ipadro,getAnio(),iordre,getNumRebut(),getPadro(),new Date(cal.getTimeInMillis()),getImportRebut().divide(new BigDecimal("2"), BigDecimal.ROUND_HALF_UP)).toString();
	}

	private String removeZeroLeft(String cad) {
		while (cad.length()>0 && cad.charAt(0)=='0')
			cad=cad.substring(1);
		return cad;
	}

	public String getTpcobro() {
		return tpcobro;
	}

	public void setTpcobro(String tpcobro) {
		this.tpcobro = tpcobro;
	}

	public String getOperaciotpv() {
		return operaciotpv;
	}

	public void setOperaciotpv(String operaciotpv) {
		this.operaciotpv = operaciotpv;
	}

	public String getMdredsys() {
		return mdredsys;
	}

	public void setMdredsys(String mdredsys) {
		this.mdredsys = mdredsys;
	}

	public String getIdredsys() {
		return idredsys;
	}

	public void setIdredsys(String idredsys) {
		this.idredsys = idredsys;
	}	
	
	
	

}