package entity.sancions;

import java.io.Serializable;

import javax.persistence.*;

import entity.comu.Domicili;
import entity.comu.Persona;
import entity.reca.Rebut;

import java.util.Date;
import java.util.List;


/**
 * The persistent class for the "Acta" database table.
 * 
 */
@Entity
@Table(name="\"Acta\"", schema = "sancions")
@NamedQuery(name="Acta.findAll", query="SELECT a FROM Acta a")
public class Acta implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer kacta;

	@Temporal(TemporalType.TIMESTAMP)
	private Date data;
	
	@Transient
	private String formattedData;

	@Column(name="num_acta")
	private Integer numActa;

	private String situampliacio;

	private String situbloc;

	private String situescala;

	private Integer situkm;

	private String situktipcarrer;

	private Integer situkvia;

	private String situlletra;

	private String situnomvia;

	private Integer situnro;

	private String situplanta;

	private String situporta;

	private String situportal;

	//uni-directional many-to-one association to Article
	@ManyToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="karticle")
	private Article article;

	@OneToOne(fetch=FetchType.LAZY, cascade=CascadeType.DETACH)
	@JoinColumn(name="krebut")
	private Rebut rebut;
	
	@Transient
	private List<FirmaActa> firmes;

	@Transient
	private List<FotoActa> fotos;
	
	
	private String descripcio;

	//uni-directional many-to-one association to Denunciat
	@ManyToOne(fetch=FetchType.LAZY, cascade=CascadeType.DETACH)
	@JoinColumn(name="kdenunciat")
	private Persona denunciat;
	
	//uni-directional many-to-one association to Denunciant
	@ManyToOne(fetch=FetchType.LAZY, cascade=CascadeType.DETACH)
	@JoinColumn(name="kdenunciant")
	private Persona denunciant;

	//uni-directional many-to-one association to Denunciat
	@ManyToOne(fetch=FetchType.LAZY, cascade=CascadeType.DETACH)
	@JoinColumn(name="kdomacc")
	private Domicili domacc;
	
	public Acta() {
	}

	public Integer getKacta() {
		return this.kacta;
	}

	public void setKacta(Integer kacta) {
		this.kacta = kacta;
	}

	public Date getData() {
		return this.data;
	}

	public void setData(Date data) {
		this.data = data;
	}


	public Integer getNumActa() {
		return this.numActa;
	}

	public void setNumActa(Integer numActa) {
		this.numActa = numActa;
	}

	public String getSituampliacio() {
		return this.situampliacio;
	}

	public void setSituampliacio(String situampliacio) {
		this.situampliacio = situampliacio;
	}

	public String getSitubloc() {
		return this.situbloc;
	}

	public void setSitubloc(String situbloc) {
		this.situbloc = situbloc;
	}

	public String getSituescala() {
		return this.situescala;
	}

	public void setSituescala(String situescala) {
		this.situescala = situescala;
	}

	public Integer getSitukm() {
		return this.situkm;
	}

	public void setSitukm(Integer situkm) {
		this.situkm = situkm;
	}

	public String getSituktipcarrer() {
		return this.situktipcarrer;
	}

	public void setSituktipcarrer(String situktipcarrer) {
		this.situktipcarrer = situktipcarrer;
	}

	public Integer getSitukvia() {
		return this.situkvia;
	}

	public void setSitukvia(Integer situkvia) {
		this.situkvia = situkvia;
	}

	public String getSitulletra() {
		return this.situlletra;
	}

	public void setSitulletra(String situlletra) {
		this.situlletra = situlletra;
	}

	public String getSitunomvia() {
		return this.situnomvia;
	}

	public void setSitunomvia(String situnomvia) {
		this.situnomvia = situnomvia;
	}

	public Integer getSitunro() {
		return this.situnro;
	}

	public void setSitunro(Integer situnro) {
		this.situnro = situnro;
	}

	public String getSituplanta() {
		return this.situplanta;
	}

	public void setSituplanta(String situplanta) {
		this.situplanta = situplanta;
	}

	public String getSituporta() {
		return this.situporta;
	}

	public void setSituporta(String situporta) {
		this.situporta = situporta;
	}

	public String getSituportal() {
		return this.situportal;
	}

	public void setSituportal(String situportal) {
		this.situportal = situportal;
	}

	public Article getArticle() {
		return this.article;
	}

	public void setArticle(Article article) {
		this.article = article;
	}

	public Persona getDenunciat() {
		return denunciat;
	}

	public void setDenunciat(Persona denunciat) {
		this.denunciat = denunciat;
	}

	public Persona getDenunciant() {
		return denunciant;
	}

	public void setDenunciant(Persona denunciant) {
		this.denunciant = denunciant;
	}

	public Domicili getDomacc() {
		return domacc;
	}

	public void setDomacc(Domicili domacc) {
		this.domacc = domacc;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public Rebut getRebut() {
		return rebut;
	}

	public void setRebut(Rebut rebut) {
		this.rebut = rebut;
	}

	public String getFormattedData() {
	  java.text.SimpleDateFormat df = new java.text.SimpleDateFormat();
	  df.applyPattern("dd/MM/yyyy HH:mm");
	  return df.format(data);
	}

	public List<FirmaActa> getFirmes() {
		return firmes;
	}

	public void setFirmes(List<FirmaActa> firmes) {
		this.firmes = firmes;
	}

	public List<FotoActa> getFotos() {
		return fotos;
	}

	public void setFotos(List<FotoActa> fotos) {
		this.fotos = fotos;
	}

	
	

}