package entity.sancions;

import java.io.Serializable;
import javax.persistence.*;

import utilities.AttributeUppercase;

import java.math.BigDecimal;


/**
 * The persistent class for the "Article" database table.
 * 
 */
@Entity
@Table(name="\"Article\"", schema = "sancions")
@NamedQuery(name="Article.findAll", query="SELECT a FROM Article a")
public class Article implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Integer karticle;

	@Convert(converter=AttributeUppercase.class)
	private String codi;

	@Convert(converter=AttributeUppercase.class)
	private String descripcio;

	@Column(name="import_maxim")
	private BigDecimal importMaxim;

	@Column(name="import_minim")
	private BigDecimal importMinim;

	@Column(name="import_sancio")
	private BigDecimal importSancio;

	public Article() {
	}

	public Integer getKarticle() {
		return this.karticle;
	}

	public void setKarticle(Integer karticle) {
		this.karticle = karticle;
	}

	public String getCodi() {
		return this.codi;
	}

	public void setCodi(String codi) {
		this.codi = codi;
	}

	public String getDescripcio() {
		return this.descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public BigDecimal getImportMaxim() {
		return this.importMaxim;
	}

	public void setImportMaxim(BigDecimal importMaxim) {
		this.importMaxim = importMaxim;
	}

	public BigDecimal getImportMinim() {
		return this.importMinim;
	}

	public void setImportMinim(BigDecimal importMinim) {
		this.importMinim = importMinim;
	}

	public BigDecimal getImportSancio() {
		return this.importSancio;
	}

	public void setImportSancio(BigDecimal importSancio) {
		this.importSancio = importSancio;
	}

}