package entity.security;

import java.io.Serializable;

import javax.persistence.*;

import jakarta.json.bind.annotation.JsonbTransient;

import java.util.List;


/**
 * The persistent class for the "MnOpcio" database table.
 * 
 */
@Entity
@Table(name="\"MnOpcio\"", schema="security")
@NamedQuery(name="MnOpcio.findAll", query="SELECT m FROM MnOpcio m")
public class MnOpcio implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	private String opcio;

	private String descripcio;

	//bi-directional many-to-one association to OpcioRole
	@OneToMany(mappedBy="mnOpcio", fetch = FetchType.LAZY)
	@JsonbTransient
	private List<OpcioRole> opcioRoles;

	//bi-directional many-to-many association to Role
	@ManyToMany(mappedBy="mnOpcions")
	@JsonbTransient
	private List<Role> roles;

	public MnOpcio() {
	}

	public String getOpcio() {
		return this.opcio;
	}

	public void setOpcio(String opcio) {
		this.opcio = opcio;
	}

	public String getDescripcio() {
		return this.descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public List<OpcioRole> getOpcioRoles() {
		return this.opcioRoles;
	}

	public void setOpcioRoles(List<OpcioRole> opcioRoles) {
		this.opcioRoles = opcioRoles;
	}

	public OpcioRole addOpcioRole(OpcioRole opcioRole) {
		getOpcioRoles().add(opcioRole);
		opcioRole.setMnOpcio(this);

		return opcioRole;
	}

	public OpcioRole removeOpcioRole(OpcioRole opcioRole) {
		getOpcioRoles().remove(opcioRole);
		opcioRole.setMnOpcio(null);

		return opcioRole;
	}

	public List<Role> getRoles() {
		return this.roles;
	}

	public void setRoles(List<Role> roles) {
		this.roles = roles;
	}

}