package entity.security;

import java.io.Serializable;

import javax.persistence.*;

import jakarta.json.bind.annotation.JsonbTransient;


/**
 * The persistent class for the "OpcioRole" database table.
 * 
 */
@Entity
@Table(name="\"OpcioRole\"", schema="security")
@NamedQuery(name="OpcioRole.findAll", query="SELECT o FROM OpcioRole o")
public class OpcioRole implements Serializable {
	private static final long serialVersionUID = 1L;

	@EmbeddedId
	private OpcioRolePK id;

	private Boolean swdelete;

	private Boolean swinsert;

	private Boolean swselect;

	private Boolean swupdate;

	//bi-directional many-to-one association to MnOpcio
	@ManyToOne
	@JoinColumn(name="opcio")
	private MnOpcio mnOpcio;

	//bi-directional many-to-one association to Role
	@ManyToOne
	@JoinColumn(name="krole")
	@JsonbTransient
	private Role role;

	public OpcioRole() {
	}

	public OpcioRolePK getId() {
		return this.id;
	}

	public void setId(OpcioRolePK id) {
		this.id = id;
	}

	public Boolean getSwdelete() {
		return this.swdelete;
	}

	public void setSwdelete(Boolean swdelete) {
		this.swdelete = swdelete;
	}

	public Boolean getSwinsert() {
		return this.swinsert;
	}

	public void setSwinsert(Boolean swinsert) {
		this.swinsert = swinsert;
	}

	public Boolean getSwselect() {
		return this.swselect;
	}

	public void setSwselect(Boolean swselect) {
		this.swselect = swselect;
	}

	public Boolean getSwupdate() {
		return this.swupdate;
	}

	public void setSwupdate(Boolean swupdate) {
		this.swupdate = swupdate;
	}

	public MnOpcio getMnOpcio() {
		return this.mnOpcio;
	}

	public void setMnOpcio(MnOpcio mnOpcio) {
		this.mnOpcio = mnOpcio;
	}

	public Role getRole() {
		return this.role;
	}

	public void setRole(Role role) {
		this.role = role;
	}

}