package entity.security;

import java.io.Serializable;
import javax.persistence.*;

/**
 * The primary key class for the "OpcioRole" database table.
 * 
 */
@Embeddable
public class OpcioRolePK implements Serializable {
	//default serial version id, required for serializable classes.
	private static final long serialVersionUID = 1L;

	@Column(insertable=false, updatable=false)
	private Integer krole;

	@Column(insertable=false, updatable=false)
	private String opcio;

	public OpcioRolePK() {
	}
	public Integer getKrole() {
		return this.krole;
	}
	public void setKrole(Integer krole) {
		this.krole = krole;
	}
	public String getOpcio() {
		return this.opcio;
	}
	public void setOpcio(String opcio) {
		this.opcio = opcio;
	}

	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if (!(other instanceof OpcioRolePK)) {
			return false;
		}
		OpcioRolePK castOther = (OpcioRolePK)other;
		return 
			this.krole.equals(castOther.krole)
			&& this.opcio.equals(castOther.opcio);
	}

	public int hashCode() {
		final int prime = 31;
		int hash = 17;
		hash = hash * prime + this.krole.hashCode();
		hash = hash * prime + this.opcio.hashCode();
		
		return hash;
	}
}