package entity.security;

import java.io.Serializable;

import javax.persistence.*;

import jakarta.json.bind.annotation.JsonbTransient;

import java.util.List;


/**
 * The persistent class for the "Role" database table.
 * 
 */
@Entity
@Table(name="\"Role\"", schema="security")
@NamedQuery(name="Role.findAll", query="SELECT r FROM Role r")
public class Role implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	private Integer krole;

	private String nom;

	//bi-directional many-to-one association to OpcioRole
	@OneToMany(mappedBy="role", fetch = FetchType.LAZY)
	@JsonbTransient
	private List<OpcioRole> opcioRoles;

	//bi-directional many-to-many association to MnOpcio
	@ManyToMany
	@JoinTable(
		name="\"OpcioRole\"",  schema="security"
		, joinColumns={
			@JoinColumn(name="krole")
			}
		, inverseJoinColumns={
			@JoinColumn(name="opcio")
			}
		)
	@JsonbTransient
	private List<MnOpcio> mnOpcions;

	//bi-directional many-to-one association to Usuari
	@OneToMany(mappedBy="role", fetch = FetchType.LAZY)
	@JsonbTransient
	private List<Usuari> usuaris;

	public Role() {
	}

	public Integer getKrole() {
		return this.krole;
	}

	public void setKrole(Integer krole) {
		this.krole = krole;
	}

	public String getNom() {
		return this.nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public List<OpcioRole> getOpcioRoles() {
		return this.opcioRoles;
	}

	public void setOpcioRoles(List<OpcioRole> opcioRoles) {
		this.opcioRoles = opcioRoles;
	}

	public OpcioRole addOpcioRole(OpcioRole opcioRole) {
		getOpcioRoles().add(opcioRole);
		opcioRole.setRole(this);

		return opcioRole;
	}

	public OpcioRole removeOpcioRole(OpcioRole opcioRole) {
		getOpcioRoles().remove(opcioRole);
		opcioRole.setRole(null);

		return opcioRole;
	}

	public List<MnOpcio> getMnOpcions() {
		return this.mnOpcions;
	}

	public void setMnOpcions(List<MnOpcio> mnOpcions) {
		this.mnOpcions = mnOpcions;
	}

	public List<Usuari> getUsuaris() {
		return this.usuaris;
	}

	public void setUsuaris(List<Usuari> usuaris) {
		this.usuaris = usuaris;
	}

	public Usuari addUsuari(Usuari usuari) {
		getUsuaris().add(usuari);
		usuari.setRole(this);

		return usuari;
	}

	public Usuari removeUsuari(Usuari usuari) {
		getUsuaris().remove(usuari);
		usuari.setRole(null);

		return usuari;
	}

}