package entity.security;

import java.io.Serializable;

import javax.persistence.*;

import utilities.AttributeEncryptor;
import utilities.AttributeUppercase;


/**
 * The persistent class for the "Usuari" database table.
 * 
 */
@Entity
@Table(name="\"Usuari\"", schema="security")
@NamedQuery(name="Usuari.findAll", query="SELECT u FROM Usuari u")
public class Usuari implements Serializable {
	public Usuari(Integer kusuari, String entrada, String nomcomplet, Role role) {
		super();
		this.kusuari = kusuari;
		this.entrada = entrada;
		this.nomcomplet = nomcomplet;
		this.role=role;
	}

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue (strategy = GenerationType.IDENTITY)
	private Integer kusuari;

	@Convert(converter=AttributeUppercase.class)
	private String entrada;

	@Convert(converter=AttributeUppercase.class)
	private String nomcomplet;

	@Convert(converter=AttributeEncryptor.class)
	private String password;
	
	private boolean canviPassword;

	//bi-directional many-to-one association to Role
	@ManyToOne
	@JoinColumn(name="krole")
	private Role role;

	public Usuari() {
	}

	public Integer getKusuari() {
		return this.kusuari;
	}

	public void setKusuari(Integer kusuari) {
		this.kusuari = kusuari;
	}

	public String getEntrada() {
		return this.entrada;
	}

	public void setEntrada(String entrada) {
		this.entrada = entrada;
	}

	public String getNomcomplet() {
		return this.nomcomplet;
	}

	public void setNomcomplet(String nomcomplet) {
		this.nomcomplet = nomcomplet;
	}

	public String getPassword() {
		return this.password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public Role getRole() {
		return this.role;
	}

	public void setRole(Role role) {
		this.role = role;
	}

	public boolean isCanviPassword() {
		return canviPassword;
	}

	public void setCanviPassword(boolean canviPassword) {
		this.canviPassword = canviPassword;
	}
	
}