package rest.sancions;

import java.util.List;

import controller.sancions.ActaCtrl;
import controller.sancions.TpvCtrl;
import es.redsys.rest.api.constants.RestConstants.Environment;
import es.redsys.rest.api.constants.RestConstants.ResultCode;
import es.redsys.rest.api.constants.RestConstants.TransactionType;
import es.redsys.rest.api.model.RestResponse;
import es.redsys.rest.api.model.message.RestAuthenticationRequestMessage;
import es.redsys.rest.api.model.message.RestInitialRequestMessage;
import es.redsys.rest.api.model.message.RestOperationMessage;
import es.redsys.rest.api.service.RestService;
import es.redsys.rest.api.service.impl.RestAuthenticationRequestService;
import es.redsys.rest.api.service.impl.RestInitialRequestService;
import es.redsys.rest.api.service.impl.RestOperationService;
import jakarta.ws.rs.Consumes;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;
import jakarta.ws.rs.core.Response;
import jaxb.redsys.Payinfo;
import jaxb.redsys.Valinfo;
import rest.security.Option;
import rest.security.Secured;

@Path("/tpv")
public class Tpv {
	static String[] digitA = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H",
			"I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };

	@POST
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_JSON)
	@Secured({ Option.SANCIO })
	@Path("/preparepay")
	public Response preparepay(Payinfo payinfo) {

		try {
			Valinfo vinfo=TpvCtrl.preparePay(payinfo);
			return Response.ok(vinfo).build();
		} catch (Exception exc) {
			return Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity(exc.getMessage()).build();
		}

	}

	
}
