CREATE SCHEMA IF NOT EXISTS security AUTHORIZATION postgres;

CREATE SCHEMA IF NOT EXISTS cadastre AUTHORIZATION postgres;

CREATE SCHEMA IF NOT EXISTS sancions AUTHORIZATION postgres;

CREATE SCHEMA IF NOT EXISTS comu AUTHORIZATION postgres;    

CREATE SCHEMA IF NOT EXISTS reca AUTHORIZATION postgres;        
    
CREATE TABLE IF NOT EXISTS security."Role" (krole integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), nom character varying(32) NOT NULL, CONSTRAINT "Role_pkey" PRIMARY KEY (krole)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE security."Role" OWNER to postgres;
     
CREATE TABLE IF NOT EXISTS security."Usuari" (kusuari integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), entrada character varying(10) NOT NULL,password character varying(32) NOT NULL, nomcomplet character varying(80) COLLATE pg_catalog."default", krole integer NOT NULL, canvipassword boolean, CONSTRAINT "Usuari_pkey" PRIMARY KEY (kusuari), CONSTRAINT krole FOREIGN KEY (krole) REFERENCES security."Role" (krole) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION, CONSTRAINT uusrentrada UNIQUE (entrada)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE security."Usuari" OWNER to postgres;      
    
CREATE TABLE IF NOT EXISTS security."MnOpcio" (opcio character varying(12) NOT NULL, descripcio character varying(20) NOT NULL, CONSTRAINT "MnOpcio_pkey" PRIMARY KEY (opcio)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE security."MnOpcio" OWNER to postgres;
      
CREATE TABLE IF NOT EXISTS security."OpcioRole" (krole integer NOT NULL, opcio character varying(12) NOT NULL,swinsert boolean,swupdate boolean,swdelete boolean,swselect boolean, CONSTRAINT "OpcionsRole_pkey" PRIMARY KEY (krole, opcio), CONSTRAINT opcio FOREIGN KEY (opcio) REFERENCES security."MnOpcio" (opcio) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION NOT VALID, CONSTRAINT role FOREIGN KEY (krole) REFERENCES security."Role" (krole) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION NOT VALID) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE security."OpcioRole" OWNER to postgres;    

CREATE TABLE IF NOT EXISTS cadastre."Pais"(kpais integer NOT NULL,nom character varying(30) NOT NULL,CONSTRAINT "Pais_pkey" PRIMARY KEY (kpais)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE cadastre."Pais" OWNER to postgres;

CREATE TABLE IF NOT EXISTS cadastre."Provincia" (kprovincia integer NOT NULL, nom character varying(30) NOT NULL, CONSTRAINT "Provincia_pkey" PRIMARY KEY (kprovincia)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE cadastre."Provincia"  OWNER to postgres;
    
CREATE TABLE cadastre."Municipi" (kmunicipi integer NOT NULL, nom character varying(30) NOT NULL, kprovincia integer NOT NULL, CONSTRAINT municipi_pkey PRIMARY KEY (kmunicipi), CONSTRAINT provmun FOREIGN KEY (kprovincia) REFERENCES cadastre."Provincia" (kprovincia) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION NOT VALID) WITH ( OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE cadastre."Municipi" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS cadastre."TipCarrer"(ktipcarrer character(3) NOT NULL, nom character varying(10) COLLATE pg_catalog."default", CONSTRAINT "TipCarrer_pkey" PRIMARY KEY (ktipcarrer)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE cadastre."TipCarrer" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS cadastre."Via" (kvia integer NOT NULL, nomvia character varying(50) NOT NULL, kmunicipi integer NOT NULL, ktipcarrer character(3) COLLATE pg_catalog."default", CONSTRAINT "Via_pkey" PRIMARY KEY (kvia), CONSTRAINT munvia FOREIGN KEY (kmunicipi) REFERENCES cadastre."Municipi" (kmunicipi) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION,CONSTRAINT tpviavia FOREIGN KEY (ktipcarrer) REFERENCES cadastre."TipCarrer" (ktipcarrer) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION ) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE cadastre."Via" OWNER to postgres;

CREATE TABLE IF NOT EXISTS sancions."Article"(karticle integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), codi character varying(10), descripcio character varying(50) NOT NULL, import_sancio numeric(6, 2), import_minim numeric(6, 2), import_maxim  numeric(6, 2), CONSTRAINT "Article_pkey" PRIMARY KEY (karticle), CONSTRAINT uartcodi UNIQUE (codi)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE sancions."Article" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS comu."Domicili" (kdomicili integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), kpais INTEGER, nompais character varying(25) NOT NULL, kvia INTEGER, kprovincia integer, kmunicipi integer, nro SMALLINT, lletra character(1), portal character varying(2)  COLLATE pg_catalog."default", bloc character(4), km INTEGER, cp character varying(5)  COLLATE pg_catalog."default", ampliacio character varying(25)  COLLATE pg_catalog."default", escala character varying(2) COLLATE pg_catalog."default", planta character varying(3) COLLATE pg_catalog."default", porta character varying(3) COLLATE pg_catalog."default", nomprovincia character varying(25) COLLATE pg_catalog."default", nommunicipi character varying(25) COLLATE pg_catalog."default", tpvia character varying(5) COLLATE pg_catalog."default", nomvia character varying(25) COLLATE pg_catalog."default", habitacio character varying(3) COLLATE pg_catalog."default", CONSTRAINT dom_pais FOREIGN KEY (kPais) REFERENCES cadastre."Pais", CONSTRAINT dom_via FOREIGN KEY (kVia) REFERENCES cadastre."Via", CONSTRAINT dom_municipi FOREIGN KEY (kmunicipi) REFERENCES cadastre."Municipi", CONSTRAINT dom_provincia FOREIGN KEY (kprovincia) REFERENCES cadastre."Provincia", CONSTRAINT "Domicili_pkey" PRIMARY KEY(kdomicili)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE comu."Domicili" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS comu."Persona"   (kpersona	integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), document character varying(10) COLLATE pg_catalog."default", tpdocument	character(3), passaport   character varying(20) COLLATE pg_catalog."default", nom character varying(25) COLLATE pg_catalog."default", llinatge1	character varying(25) COLLATE pg_catalog."default", llinatge2 character varying(25) COLLATE pg_catalog."default",  nomcomplet character varying(60) COLLATE pg_catalog."default", tppersona   character(1), sexe  character(1), telefon character varying(12) COLLATE pg_catalog."default", email character varying(32) COLLATE pg_catalog."default", dataneixement date, knacionalitat integer, dencomerc character varying(60) COLLATE pg_catalog."default", activitat character varying(60) COLLATE pg_catalog."default",  kdomnotif integer,  CONSTRAINT pers_domnotif FOREIGN KEY (kdomnotif) REFERENCES comu."Domicili",  CONSTRAINT pers_nacionalitat FOREIGN KEY (knacionalitat) REFERENCES cadastre."Pais",  CONSTRAINT "Persona_pkey" PRIMARY KEY(kpersona),  CONSTRAINT upersdocument UNIQUE (document)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE comu."Persona" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS reca."Rebut" (krebut integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ), padro character varying(2) COLLATE pg_catalog."default",   anio smallint,  ordre character varying(2) COLLATE pg_catalog."default",  num_rebut integer, kpersona integer,  data date, import_rebut numeric(12,2),  estat character(1) COLLATE pg_catalog."default", data_cobro date, tpcobro character(1) COLLATE pg_catalog."default", operaciotpv character varying(20) COLLATE pg_catalog."default",  mdredsys character varying(50) COLLATE pg_catalog."default",  idredsys character varying(50) COLLATE pg_catalog."default",  CONSTRAINT "Rebut_pkey" PRIMARY KEY (krebut), CONSTRAINT urebut UNIQUE (padro, anio, ordre, num_rebut), CONSTRAINT reca_persona FOREIGN KEY (kpersona) REFERENCES comu."Persona" (kpersona) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION) TABLESPACE pg_default;
ALTER TABLE reca."Rebut" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS reca."Redsys" (mdredsys varchar(50) not null,	acsurl varchar(200), pareq text, CONSTRAINT "Redsys_pkey" PRIMARY KEY(mdredsys));
ALTER TABLE reca."Redsys" OWNER to postgres;

CREATE TABLE IF NOT EXISTS sancions."Acta" (kacta integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),	karticle integer not null,	descripcio text,	num_acta integer not null,	data timestamp,	situkvia integer,	situktipcarrer character(3) COLLATE pg_catalog."default",	situnomvia character varying(50) COLLATE pg_catalog."default" NOT NULL,    situnro SMALLINT,    situlletra character(1),    situportal character varying(2),    situbloc character(4),    situkm INTEGER,    situampliacio character varying(25)  COLLATE pg_catalog."default",    situescala character varying(2) COLLATE pg_catalog."default",    situplanta character varying(3) COLLATE pg_catalog."default",    situporta character varying(3) COLLATE pg_catalog."default",    kdenunciat integer not null,    kdenunciant integer,    kdomacc integer,    krebut integer,    CONSTRAINT acta_domacc FOREIGN KEY (kdomacc) REFERENCES comu."Domicili",    CONSTRAINT acta_article FOREIGN KEY (karticle) REFERENCES sancions."Article",    CONSTRAINT acta_denunciat FOREIGN KEY (kdenunciat) REFERENCES comu."Persona",    CONSTRAINT acta_denunciant FOREIGN KEY (kdenunciant) REFERENCES comu."Persona",    CONSTRAINT acta_situtpcarrer FOREIGN KEY (situktipcarrer) REFERENCES cadastre."TipCarrer",    CONSTRAINT acta_rebut FOREIGN KEY (krebut) REFERENCES reca."Rebut",	CONSTRAINT "Acta_pkey" PRIMARY KEY(kacta)) WITH (OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE sancions."Acta" OWNER to postgres;

    
CREATE TABLE IF NOT EXISTS sancions."FirmaActa" (kfirmaacta integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),kacta integer not null,origen character(2),firmant character varying(20),data text,  CONSTRAINT firma_acta FOREIGN KEY (kacta) REFERENCES sancions."Acta",   CONSTRAINT "FirmaActa_pkey" PRIMARY KEY(kfirmaacta)) WITH (   OIDS = FALSE) TABLESPACE pg_default;
ALTER TABLE sancions."FirmaActa" OWNER to postgres;
    
CREATE TABLE IF NOT EXISTS sancions."FotoActa" (kfotoacta integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),	kacta integer not null,	data text,    CONSTRAINT foto_acta FOREIGN KEY (kacta) REFERENCES sancions."Acta",    CONSTRAINT "FotoActa_pkey" PRIMARY KEY(kfotoacta)	)    WITH ( OIDS = FALSE) TABLESPACE pg_default;

ALTER TABLE sancions."FotoActa" OWNER to postgres;

    
CREATE OR REPLACE VIEW comu."VwSancionat"
 AS
 SELECT pers.kpersona,
    pers.document,
    pers.passaport,
    pers.nom,
    pers.llinatge1,
    pers.llinatge2,
    pers.dencomerc,
    pers.tpdocument,
    ( SELECT count(act.kacta) AS count
           FROM sancions."Acta" act
          WHERE act.kdenunciat = pers.kpersona) AS numsancions
   FROM comu."Persona" pers;

ALTER TABLE comu."VwSancionat"
    OWNER TO postgres;       
